openapi: 3.0.3
info:
  title: xtremepush-lithium-core-api
  version: 1.0.0
servers:
  - url: "https://gateway.lithium-develop.ls-g.net"
    description: Livescore Lithium Develop
  - url: "https://gateway.lithium-qa.ls-g.net"
    description: Livescore Lithium QA
  - url: "https://gateway.lithium-staging.ls-g.net/"
    description: Livescore Lithium Staging
  - url: "https://gateway.lithium-prod.ls-g.net"
    description: Livescore Lithium Production
  - url: '{protocol}://{ngrok}.ngrok.io'
    description: Ngrok pointing to a local gateway.
    variables:
      ngrok:
        description: ngrok variable
        default: 6bd36c31
      protocol:
        enum:
          - http
          - https
        default: https
  - url: 'http://localhost:9000'
    description: Local Gateway.
  - url: '{custom_server}'
    description: Easy entry to point this to any gateway server for testing.
    variables:
      custom_server:
        description: gateway server url
        default: http://localhost:9000
tags:
  - name: User Authentication
    description: Oauth2 user authentication for all API calls.
  - name: OptOut
    description: The OptOut process for customers.
  - name: Trigger Bonus
    description: This endpoint triggers the bonus
#  - name: Games
#   description: How to view available games, and start a game.
#  - name: Frontend User Email Validation
#   description: The email validaiton process for new customers.
#  - name: Frontend Product Service
#   description: Retrieve product details.
  
paths:


   ##### server-oauth backoffice #####
  /server-oauth2/backoffice/oauth/token:
    post:
      tags:
        - User Authentication
      summary: Oauth2 backoffice authentication
      description: >-
        This endpoint is used to obtain a player auth token used with future requests that require authentication.
      security:
        - basicAuth: []
      parameters:
        - name: authHeader
          required: false
          in: header
          schema:
            type: string
          description: Authorization Header 

      requestBody:
        required: true
        content:
          application/x-www-form-urlencoded:
            schema:
              oneOf:
                - $ref: '#/components/schemas/AccessTokenRequest'
                - $ref: '#/components/schemas/AccessTokenRefreshRequest'
            example:
              grant_type: password
              username: livescore_nigeria/riaans1
              password: Password12
            # examples:
            #   AccessTokenRequestExample:
            #     summary: Example of sending an AccessTokenRequest
            #     value:
            #       grant_type: password
            #       username: livescore_nigeria/riaans1
            #       password: Password12
            #   AccessTokenRefreshRequestExample:
            #     summary: Example of sending an AccessTokenRefreshRequest
            #     value:
            #       grant_type: refresh_token
            #       refresh_token: TOKEN
      responses:
        '200':
          description: Contains the access token that is required for most other calls to lithium.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/AccessTokenResponse'
        '400':
          description: Bad request
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorResponse'
              example:
                error: unsupported_grant_type
                error_description: Invalid grant_type specified.
        '403':
          description: Invalid username or password.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorResponse'
              example:
                error: access_denied
                error_description: Your username or password is incorrect.
        '405':
          description: Your account is disabled.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorResponse'
              example:
                error: access_denied
                error_description: Your account is currently disabled. Please contact customer support.
        '407':
          description: IP Blocked.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorResponse'
              example:
                error: access_denied
                error_description: Your IP address is currently blocked. Please contact customer support.
        '428':
          description: Account Frozen - Gamstop Self Excluded.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorResponse'
              example:
                error: access_denied
                error_description: Account is frozen. Gamstop self excluded.
        '430':
          description: The player has an account in the ecosystem but additional information is required to register on the brand.
          content:
            application/json:
              schema:
                  $ref: '#/components/schemas/ErrorResponseExtended'
              example:
                firstName: Lethu
                lastName: Dlamini
                dobDay: 5
                dobMonth: 6
                dobYear: 2001
                email: lethu@wonderlabz.com
                uuid: 187169d8-3874-45cd-b9b3-ebbe6e4b4c2b
                error: registration_upgrade_required
                error_description: You need to provide additional information to complete registration.
        '432':
          description: The player already has an account in the ecosystem and has an account on another mutually exclusive domain. Try logging in using the correct domain name in your username combination. domainName = {domainName}.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorCodeResponse'
        '433':
          description: Account Blocked - Player Request.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorResponse'
              example:
                error: access_denied
                error_description: Account is blocked. Player request.
        '434':
          description: Account Blocked - Responsible Gaming.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorResponse'
              example:
                error: access_denied
                error_description: Account is blocked. Responsible gaming.
        '435':
          description: Account Blocked - AML.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorResponse'
              example:
                error: access_denied
                error_description: Account is blocked. AML.
        '436':
          description: Account Blocked - Duplicated Account.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorResponse'
              example:
                error: access_denied
                error_description: Account is blocked. Duplicated account.
        '437':
          description: Account Blocked - Other.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorResponse'
              example:
                error: access_denied
                error_description: Account is blocked. Other.
        '447':
          description: Account Frozen.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorResponse'
              example:
                error: access_denied
                error_description: Account is frozen.
        '448':
          description: Account Blocked.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorResponse'
              example:
                error: access_denied
                error_description: Account is blocked.
        '449':
          description: Account Frozen - Cooling Off.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorResponse'
              example:
                error: access_denied
                error_description: Account is frozen. Cooling off.
        '450':
          description: Account Frozen - Self Excluded.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorResponse'
              example:
                error: access_denied
                error_description: Account is frozen. Self excluded.
        '455':
          description: Account Blocked - Fraud.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorResponse'
              example:
                error: access_denied
                error_description: Account is blocked. Fraud.
        '460':
          description: Login Restricted.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorResponse'
              example:
                error: access_denied
                error_description: Your account is currently restricted. Please contact customer support.
        '465':
          description: Access to Login from Unknown Country is Denied.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorResponse'
              example:
                error: access_denied
                error_description: You can't login from an unknown country. Please contact customer support.
        '490':
          description: Soft self exclusion.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorResponse'
              example:
                error: access_denied
                error_description: You have excluded yourself from playing until 2020-05-13
        '491':
          description: Permanent self exclusion.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorResponse'
              example:
                error: access_denied
                error_description: You have excluded yourself permanently from playing.
        '492':
          description: Excessive failed logins.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorResponse'
              example:
                error: TODO
                error_description: TODO
        '496':
          $ref: "#/components/responses/496PlayerCoolingOff"
        '500':
          description: Internal server error
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorResponse'
              example:
                error: access_denied
                error_description: >-
                  Limit service client exception: getPlayerExclusion failed and no fallback available.

  /server-oauth2/oauth/refreshtoken:
    post:
      tags:
        - User Authentication
      summary: Refreshes Oauth2 user authentication token
      description: >-
        This endpoint is used to refresh a user auth token.
      security:
        - httpBearer: []
      requestBody:
        required: true
        content:
          application/x-www-form-urlencoded:
            schema:
              oneOf:
                - $ref: '#/components/schemas/AccessTokenRefreshRequest'
            example:
              grant_type: refresh_token
              refresh_token: TOKEN

      responses:
        '200':
          description: Contains the access token that is required for most other calls to lithium.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/AccessTokenResponse'
        '400':
          description: Bad request
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorResponse'
              example:
                error: unsupported_grant_type
                error_description: Invalid grant_type specified.
        '403':
          description: Invalid username or password.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorResponse'
              example:
                error: access_denied
                error_description: Your username or password is incorrect.
        '405':
          description: Your account is disabled.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorResponse'
              example:
                error: access_denied
                error_description: Your account is currently disabled. Please contact customer support.
        '407':
          description: IP Blocked.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorResponse'
              example:
                error: access_denied
                error_description: Your IP address is currently blocked. Please contact customer support.
        '428':
          description: Account Frozen - Gamstop Self Excluded.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorResponse'
              example:
                error: access_denied
                error_description: Account is frozen. Gamstop self excluded.
        '430':
          description: The player has an account in the ecosystem but additional information is required to register on the brand.
          content:
            application/json:
              schema:
                  $ref: '#/components/schemas/ErrorResponseExtended'
              example:
                firstName: Lethu
                lastName: Dlamini
                dobDay: 5
                dobMonth: 6
                dobYear: 2001
                email: lethu@wonderlabz.com
                uuid: 187169d8-3874-45cd-b9b3-ebbe6e4b4c2b
                error: registration_upgrade_required
                error_description: You need to provide additional information to complete registration.
        '433':
          description: Account Blocked - Player Request.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorResponse'
              example:
                error: access_denied
                error_description: Account is blocked. Player request.
        '434':
          description: Account Blocked - Responsible Gaming.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorResponse'
              example:
                error: access_denied
                error_description: Account is blocked. Responsible gaming.
        '435':
          description: Account Blocked - AML.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorResponse'
              example:
                error: access_denied
                error_description: Account is blocked. AML.
        '436':
          description: Account Blocked - Duplicated Account.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorResponse'
              example:
                error: access_denied
                error_description: Account is blocked. Duplicated account.
        '437':
          description: Account Blocked - Other.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorResponse'
              example:
                error: access_denied
                error_description: Account is blocked. Other.
        '447':
          description: Account Frozen.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorResponse'
              example:
                error: access_denied
                error_description: Account is frozen.
        '448':
          description: Account Blocked.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorResponse'
              example:
                error: access_denied
                error_description: Account is blocked.
        '449':
          description: Account Frozen - Cooling Off.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorResponse'
              example:
                error: access_denied
                error_description: Account is frozen. Cooling off.
        '450':
          description: Account Frozen - Self Excluded.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorResponse'
              example:
                error: access_denied
                error_description: Account is frozen. Self excluded.
        '455':
          description: Account Blocked - Fraud.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorResponse'
              example:
                error: access_denied
                error_description: Account is blocked. Fraud.
        '460':
          description: Login Restricted.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorResponse'
              example:
                error: access_denied
                error_description: Your account is currently restricted. Please contact customer support.
        '490':
          description: Soft self exclusion.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorResponse'
              example:
                error: access_denied
                error_description: You have excluded yourself from playing until 2020-05-13
        '491':
          description: Permanent self exclusion.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorResponse'
              example:
                error: access_denied
                error_description: You have excluded yourself permanently from playing.
        '492':
          description: Excessive failed logins.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorResponse'
              example:
                error: TODO
                error_description: TODO
        '496':
          $ref: "#/components/responses/496PlayerCoolingOff"
        '500':
          description: Internal server error
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorResponse'
              example:
                error: access_denied
                error_description: >-
                  Limit service client exception: getPlayerExclusion failed and no fallback available.


  /server-oauth2/token/refresh:
    post:
      tags:
        - User Authentication
      summary: Public request for refresh Oauth2 user authentication token
      description: >-
        This endpoint is used to refresh a user auth token.
      security: []
      requestBody:
        required: true
        content:
          application/x-www-form-urlencoded:
            schema:
              oneOf:
                - $ref: '#/components/schemas/AccessTokenRefreshRequest'
            example:
              grant_type: refresh_token
              refresh_token: TOKEN

      responses:
        '200':
          description: Contains the access token that is required for most other calls to lithium.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/AccessTokenResponse'
        '400':
          description: Bad request
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorResponse'
              example:
                error: unsupported_grant_type
                error_description: Invalid grant_type specified.
        '403':
          description: Invalid username or password.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorResponse'
              example:
                error: access_denied
                error_description: Your username or password is incorrect.
        '405':
          description: Your account is disabled.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorResponse'
              example:
                error: access_denied
                error_description: Your account is currently disabled. Please contact customer support.
        '407':
          description: IP Blocked.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorResponse'
              example:
                error: access_denied
                error_description: Your IP address is currently blocked. Please contact customer support.
        '428':
          description: Account Frozen - Gamstop Self Excluded.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorResponse'
              example:
                error: access_denied
                error_description: Account is frozen. Gamstop self excluded.
        '430':
          description: The player has an account in the ecosystem but additional information is required to register on the brand.
          content:
            application/json:
              schema:
                  $ref: '#/components/schemas/ErrorResponseExtended'
              example:
                firstName: Lethu
                lastName: Dlamini
                dobDay: 5
                dobMonth: 6
                dobYear: 2001
                email: lethu@wonderlabz.com
                uuid: 187169d8-3874-45cd-b9b3-ebbe6e4b4c2b
                error: registration_upgrade_required
                error_description: You need to provide additional information to complete registration.
        '433':
          description: Account Blocked - Player Request.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorResponse'
              example:
                error: access_denied
                error_description: Account is blocked. Player request.
        '434':
          description: Account Blocked - Responsible Gaming.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorResponse'
              example:
                error: access_denied
                error_description: Account is blocked. Responsible gaming.
        '435':
          description: Account Blocked - AML.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorResponse'
              example:
                error: access_denied
                error_description: Account is blocked. AML.
        '436':
          description: Account Blocked - Duplicated Account.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorResponse'
              example:
                error: access_denied
                error_description: Account is blocked. Duplicated account.
        '437':
          description: Account Blocked - Other.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorResponse'
              example:
                error: access_denied
                error_description: Account is blocked. Other.
        '447':
          description: Account Frozen.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorResponse'
              example:
                error: access_denied
                error_description: Account is frozen.
        '448':
          description: Account Blocked.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorResponse'
              example:
                error: access_denied
                error_description: Account is blocked.
        '449':
          description: Account Frozen - Cooling Off.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorResponse'
              example:
                error: access_denied
                error_description: Account is frozen. Cooling off.
        '450':
          description: Account Frozen - Self Excluded.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorResponse'
              example:
                error: access_denied
                error_description: Account is frozen. Self excluded.
        '455':
          description: Account Blocked - Fraud.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorResponse'
              example:
                error: access_denied
                error_description: Account is blocked. Fraud.
        '460':
          description: Login Restricted.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorResponse'
              example:
                error: access_denied
                error_description: Your account is currently restricted. Please contact customer support.
        '490':
          description: Soft self exclusion.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorResponse'
              example:
                error: access_denied
                error_description: You have excluded yourself from playing until 2020-05-13
        '491':
          description: Permanent self exclusion.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorResponse'
              example:
                error: access_denied
                error_description: You have excluded yourself permanently from playing.
        '492':
          description: Excessive failed logins.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorResponse'
              example:
                error: TODO
                error_description: TODO
        '496':
          $ref: "#/components/responses/496PlayerCoolingOff"
        '500':
          description: Internal server error
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorResponse'
              example:
                error: access_denied
                error_description: >-
                  Limit service client exception: getPlayerExclusion failed and no fallback available.
   
   ##### OptOut API #####
  /service-user/backoffice/player_domain/profile/opt:
    post:
      tags:
        - OptOut
      summary: OptOut API
      description: >-
        This endpoint is used to enable players to OptOut.
      security:
        - basicAuth: []
      parameters:
        - name: domainName
          required: true
          allowEmptyValue: false
          in: query
          schema:
            type: string
          description: The player domain

      requestBody:
        required: true
        content:
          application/x-www-form-urlencoded:
            schema:
              oneOf:
                - $ref: '#/components/schemas/OptRequest'
            example:
              method: email
              optOut: true
              guid: 6B29FC40-CA47-1067-B31D-00DD010662DA
              description: enable player to OptOut

      responses:
        '200':
          description: Contains the access token that is required for most other calls to lithium.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ResponseEntity'
        '404':
          description: |-
            User not found.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/Error500Response'            
        '500':
          description: |-
            Something went wrong in the request to Opt.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/Error500Response'
              example:
                timestamp: 1588524610927
                status: 500
                error: Internal Server Error

##### Trigger Bonus #####
  /service-casino-provider-slotapi/bonus/trigger:
    post:
      tags:
        - Trigger Bonus
      summary: Trigger Bonus
      description: >-
        This endpoint is used to trigger bonus.
      security:
        - basicAuth: []
      parameters:
        - name: Authorization
          required: true
          in: header
          schema:
            type: string
          description: Authorization Header 

      requestBody:
        required: true
        content:
          application/x-www-form-urlencoded:
            schema:
              oneOf:
                - $ref: '#/components/schemas/BonusRequest'
            example:
              playerGuid: 6B29FC40-CA47-1067-B31D-00DD010662DA
              requestId: 7445
              customAmountDecimal: 2345
              bonusCode: BN256
              description: Bonus triggering process
              sha256: ba7816bf8f01cfea414140de5dae2223b00361a396177a9cb410ff61f20015ad
        
      responses:
        '200':
          description: Bonus Trigger request process successful
          content:
            application/json:
              schema:
                type: number
        '422':
          description: Problem registering the bonus.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorCodeResponse'
        '444':
          description: Problem registering the bonus.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorCodeResponse'   
        '470':
          description: Hash invalid
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorCodeResponse'    
        '500':
          description: |-
            Something went wrong in the request to trigger bonus.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/Error500Response'
              example:
                timestamp: 1588524610927
                status: 500
                error: Internal Server Error

components:
  examples:
    unauthorized:
      value:
        error: unauthorized
        error_description: Full authentication is required to access this resource
    Error401Response:
      value:
        timestamp: 1585635150137
        status: 401
        error: Unauthorized
        message: Full authentication is required to access this resource
        path: /oauth/token
  responses:
    unauthorized:
      description: The response for an unauthorized request.
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/Unauthorized'
          examples:
            unauthorized:
              $ref: '#/components/examples/unauthorized'
    401Response:
      description: The response for an unauthorized request.
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/Error401Response'
          examples:
            Error401Response:
              $ref: '#/components/examples/Error401Response'
    496PlayerCoolingOff:
      description: Player account is flagged as cooling off.
    478BlockedByTimeSlotLimit:
      description: Current Time Slot Limit prevents this action.
    477DomainNotConfigured:
      description: Domain not configured to check for Time Slot Limit.
  schemas:
    NullHandling:
      type: string
      title: NullHandling
      enum:
        - NATIVE
        - NULLS_FIRST
        - NULLS_LAST
    Direction:
      type: string
      title: Direction
      enum:
        - ASC
        - DESC
    Order:
      type: object
      title: Order
      properties:
        direction:
          $ref: '#/components/schemas/Direction'
        property:
          type: string
        ignoreCase:
          type: boolean
        nullHandling:
          $ref: '#/components/schemas/NullHandling'
    Sort:
      type: object
      title: Sort
      properties:
        orders:
          type: array
          items:
            $ref: '#/components/schemas/Order'
    UserApiToken:
      type: object
      title: UserApiToken
      properties:
        id:
          type: integer
          format: int64
        token:
          type: string
        guid:
          type: string
        shortGuid:
          type: string
        # user:
        #   $ref: '#/components/schemas/User'
    OptInOut:
      type: object
      title: OptInOut
      properties:
        method:
          type: string
          enum: [email, post, sms, call, push, leaderboard]
        optOut:
          type: boolean
        guid:
          type: string
        description:
          type: string
    DepositLimitSet:
      type: object
      title: DepositLimitSet
      properties:
        granularity:
          type: array
          example: [3,4]
          items:
            type: integer
        amounts:
          type: array
          example: [ 0, 5000.52 ]
          items:
            type: number
            format: double
    FrontendPlayerBasic:
      type: object
      title: FrontendPlayerBasic
      properties:
        firstName:
          type: string
          example: Riaan
        lastNamePrefix:
          type: string
        lastName:
          type: string
          example: Schoeman
        countryCode:
          type: string
          example: ZA
        placeOfBirth:
          type: string
          example: Praag
        telephoneNumber:
          type: string
        cellphoneNumber:
          type: string
        dobYear:
          type: integer
          format: int32
        dobMonth:
          type: integer
          format: int32
        dobDay:
          type: integer
          format: int32
        timezone:
          type: string
        gender:
          type: string
        emailOptOut:
          type: boolean
        postOptOut:
          type: boolean
        smsOptOut:
          type: boolean
        callOptOut:
          type: boolean
        pushOptOut:
          type: boolean
        leaderboardOptOut:
          type: boolean
        parentEmailOptOut:
          type: boolean
        parentPostOptOut:
          type: boolean
        parentSmsOptOut:
          type: boolean
        parentCallOptOut:
          type: boolean
        parentPushOptOut:
          type: boolean
        parentLeaderboardOptOut:
         type: boolean

    PasswordBasic:
      type: object
      title: PasswordBasic
      properties:
        currentPassword:
          type: string
        newPassword:
          type: string
        confirmPassword:
          type: string
    ProfileRequirements:
      type: object
      title: ProfileRequirements
      properties:
        id:
          type: integer
          format: int64
        version:
          type: integer
          format: int32
        totalDeposits:
          type: integer
          format: int64
        totalPayouts:
          type: integer
          format: int64
        numberDeposits:
          type: integer
          format: int32
        numberPayouts:
          type: integer
          format: int32
        accountActiveDays:
          type: integer
          format: int32
        # profile:   # <-- Circular dependency
        #   $ref: '#/components/schemas/Profile'
    Profile:
      type: object
      title: Profile
      properties:
        id:
          type: integer
          format: int64
        version:
          type: integer
          format: int32
        code:
          type: string
        name:
          type: string
        description:
          type: string
        domain:
          $ref: '#/components/schemas/Domain'
        profileRequirements:
          $ref: '#/components/schemas/ProfileRequirements'
        # users:
        #   type: array
        #   items:
        #     $ref: '#/components/schemas/User'
        # domainMethodProfiles:
        #   type: array
        #   items:
        #     $ref: '#/components/schemas/DomainMethodProfile'
    Domain:
      type: object
      title: Domain
      required:
        - id
        - name
      properties:
        id:
          type: integer
          format: int64
        version:
          type: integer
          format: int32
        name:
          type: string
      example:
        id: 2
        version: 0
        name: livescore_nigeria
    User.StatusReason:
      type: object
      title: lithium.service.user.data.entities.StatusReason
      description: This status reason object relates to the User object
      properties:
        id:
          type: integer
          format: int64
        version:
          type: integer
          format: int32
        name:
          type: string
        description:
          type: string
    Common.Status:
      type: object
      title: Status
      required:
        - id
        - message
      properties:
        id:
          type: integer
          format: int32
        message:
          type: string
      # nullable: true
      # enum:
      #   - OK
      #   - EXISTS
      #   - PRECONDITION_FAILED
      #   - UNAUTHORIZED
      #   - FORBIDDEN
      #   - NOT_FOUND
      #   - CONFLICT
      #   - INTERNAL_SERVER_ERROR
      #   - NOT_IMPLEMENTED
      #   - SERVICE_UNAVAILABLE
      #   - INVALID_DATA
      #   - null
    HttpHeaders:
      type: object
      title: HttpHeaders
      properties:
        headers:
          type: object
          additionalProperties:
            type: array
            items:
              type: string
        # HttpEntity:
        #   type: object
        #   title: HttpEntity
        #   properties:
        # body:
        #   type: object
        # headers:
        #   $ref: '#/components/schemas/HttpHeaders'
    ResponseEntity:
      type: object
      title: ResponseEntity
      # discriminator:
      #   propertyName: body
      # allOf:     # Combines the HttpEntity and the inline model
      # - $ref: '#/components/schemas/HttpEntity'
      # - type: object
      properties:
        statusCode:
          type: object
        body:
          type: object
        headers:
          $ref: '#/components/schemas/HttpHeaders'
    Response:
      type: object
      title: Response
      properties:
        data:
          type: object
        data2:
          type: object
        message:
          type: string
        status:
          type: integer
          format: int32
          example: 0
          # enum:
          #   - OK
          #   - EXISTS
          #   - PRECONDITION_FAILED
          #   - UNAUTHORIZED
          #   - FORBIDDEN
          #   - NOT_FOUND
          #   - CONFLICT
          #   - INTERNAL_SERVER_ERROR
          #   - NOT_IMPLEMENTED
          #   - SERVICE_UNAVAILABLE
          #   - INVALID_DATA
          #   - null
          # $ref: '#/components/schemas/Status'
        successful:
          type: boolean
    Unauthorized:
      type: object
      title: Unauthorized
      properties:
        error:
          type: string
        error_description:
          type: string
      example:
        error: Unauthorized
        error_description: Full authentication is required to access this resource
    Error401Response:
      type: object
      title: Error401Response
      properties:
        timestamp:
          type: integer
          format: int64
        status:
          type: integer
          format: int32
        error:
          type: string
        message:
          type: string
        path:
          type: string
      example:
        timestamp: 1585635150136
        status: 401
        error: Unauthorized
        message: Full authentication is required to access this resource
        path: /oauth/token

    Error500Response:
      type: object
      title: Error500Response
      properties:
        timestamp:
          type: integer
          format: int64
        status:
          type: integer
          format: int32
        error:
          type: string
        exception:
          type: string
        message:
          type: string
        path:
          type: string

    ErrorCodeResponse:
      type: object
      title: ErrorCodeResponse
      properties:
        status:
          type: integer
        error:
          type: string
          description: A machine code uniquely describing the error
        error_description:
          type: string
          description: A human readable english message describing the error
        message:
          type: string
          description: A human readable english message describing the error
        exception:
          type: string
          description: The exception class that caused this error

    ErrorResponseExtended:
      type: object
      title: ErrorResponseExtended
      properties:
        code:
          type: integer
          default: 430
        status:
          type: boolean
          default: false
        uuid:
          type: string
          description: |
            When the user exists on a root ecosystem domain and tries to log into a mutually exclusive domain, a UUID would be returned on the response along with a 430 User Upgrade Required Exception. This UUID and email needs to be included on the PlayerBasic when registering the user on the mutually exclusive domain.
        firstName:
          type: string
        lastName:
          type: string
        email:
          type: string
        dobDay:
          type: integer
          format: int32
        dobMonth:
          type: integer
          format: int32
        dobYear:
          type: integer
          format: int32
        error:
          type: string
          default: registration_upgrade_required
        error_description:
          type: string
          default: You need to upgrade your registration to continue.
    ErrorResponse:
      type: object
      title: ErrorResponse
      properties:
        code:
          type: integer
          default: 400
        status:
          type: boolean
          default: false
        data:
          type: string
          default: 'null'
        error:
          type: string
          default: unauthorized_client
        error_description:
          type: string
          default: Your username or password is incorrect.
    OptRequest:
      type: object
      title: OptRequest
      properties:
        method:
          type: string
          example: email
          description: Method value
        optOut:
          type: boolean
          example: true
          description: OptOut value, true or false
        guid:
          type: string
          example: 6B29FC40-CA47-1067-B31D-00DD010662DA
          description: Player Guid value
        description:
          type: string
          example: player OptIn
          description: enable player to OptOut
    BonusRequest:
      type: object
      title: BonusRequest
      properties:
        playerGuid:
          type: string
          example: 6B29FC40-CA47-1067-B31D-00DD010662DA
          description: Player Guid value
        requestId:
          type: integer
          example: 3434
          description: requestId value
        customAmountDecimal:
          type: number
          example: 3434
          description: customAmountDecimal value
        bonusCode:
          type: string
          example: BN004
        description:
          type: string
          example: Bonus triggering process
        sha256:
          type: string
          example: ba7816bf8f01cfea414140de5dae2223b00361a396177a9cb410ff61f20015ad
    AccessTokenRequest:
      type: object
      title: AccessTokenRequest
      properties:
        grant_type:
          type: string
          example: password
          description: This value should always be 'password' when authenticating a username and password
        username:
          type: string
          example: klimalotteriet/riaans1
          description: |
            In most cases, you may authenticate using the domainname/username combination e.g klimalotteriet/riaans1

            Should your user be registered to a mutually exclusive domain, then you may also make use of the ecosystemname/username combination to authenticate a user.
        password:
          type: string
          example: Password12
          description: The password for the username specified above. e.g. Password12
    AccessTokenRefreshRequest:
      type: object
      title: AccessTokenRefreshRequest
      properties:
        grant_type:
          type: string
          example: refresh_token
          description: This value should always be 'refresh_token' for a refresh token request
        refresh_token:
          type: string
          description: The refresh token received during the password authentication request
    AccessTokenResponse:
      type: object
      title: AccessTokenResponse
      properties:
        access_token:
          type: string
          description: The access token required for auth.
        token_type:
          type: string
          description: token_type
          example: bearer
        refresh_token:
          type: string
          description: refresh_token
        expires_in:
          type: string
          description: expires_in
        scope:
          type: string
          description: scope
        jwtUser:
          type: string
          description: jwtUser
        jti:
          type: string
          description: jti
        userId:
          type: integer
          format: int64
          description: userId
        username:
          type: string
          description: username
        email:
          type: string
          description: email
        userGuid:
          type: string
          description: user guid
        shortGuid:
          type: string
          description: short guid
        firstName:
          type: string
          description: first name
        lastName:
          type: string
          description: last name
        registrationDate:
          type: integer
          format: int64
          description: date of registration
        sessionId:
          type: integer
          format: int64
          description: session id
        lastLogin:
          type: integer
          format: int64
          description: last login timestamp
        lastIP:
          type: string
          description: last ip address
        optOutEmail:
          type: boolean
          description: email subscription
        optOutSms:
          type: boolean
          description: sms subscription
        optOutCall:
          type: boolean
          description: call subscription
        optOutPush:
          type: boolean
          description: push subscription
        optOutPost:
          type: boolean
          description: post subscription
        promotionsOptOut:
          type: boolean
          description: promotions subscription
        verificationLevel:
          type: number
          format: int32
          description: |-
            The verification level of the user. :
            | level | status |
            |---|---|
            |  0  | UNVERIFIED |
            |  1  | MANUALLY_VERIFIED |
            |  1  | EXTERNALLY_VERIFIED |
            |  2  | SOF_VERIFIED |
            | -1  | UNDERAGED |
            |  1  | AGE_ONLY_VERIFIED |
          example: 0
        ageVerified:
          type: boolean
        addressVerified:
          type: boolean
        contraAccountSet:
          type: boolean
        commsOptInComplete:
          type: boolean
          description: A flag to indicate whether a player has been asked if they would like to opt in to marketing communication.
          example: false
        termsAndConditionsVersion:
          $ref: '#/components/schemas/TermsAndConditionsVersion'
        restrictions:
          $ref: '#/components/schemas/Restrictions'
    UserPasswordReset:
      type: object
      title: UserPasswordReset
      properties:
        token:
          type: string
        password:
          type: string
    DoRequest:
      type: object
      title: DoRequest
      properties:
        transactionId:
          type: integer
          format: int64
        inputFieldGroups:
          type: object
          additionalProperties:
            $ref: '#/components/schemas/DoStateFieldGroup'
        stage:
          type: integer
          format: int32
        state:
          type: string
        mobile:
          type: boolean
        deviceId:
          type: string
    DoResponse:
      type: object
      title: DoResponse
      properties:
        transactionId:
          type: integer
          format: int64
        title:
          type: string
        description:
          type: string
        # Map<String, DoStateFieldGroup>
        inputFieldGroups:
          type: object
          additionalProperties:
            $ref: '#/components/schemas/DoStateFieldGroup'
        # Map<String, DoStateField>
        outputFields:
          type: object
          additionalProperties:
            $ref: '#/components/schemas/DoStateField'
        stage:
          type: integer
          format: int32
        state:
          type: string
        error:
          type: boolean
        errorMessage:
          type: string
        stacktrace:
          type: string
        iframeUrl:
          type: string
        iframeMethod:
          type: string
        # Map<String, String>
        iframePostData:
          type: object
          additionalProperties:
            type: string
        redirectUrl:
          type: string
        mobile:
          type: boolean
        methodCode:
          type: string
        processorCode:
          type: string
        amountCents:
          type: integer
          format: int64
        iframeWindowTarget:
          description: Setting this to _blank will cause a form post to a blank window
          type: string
    DoStateFieldGroup:
      type: object
      title: DoStateFieldGroup
      properties:
        header:
          type: string
        description:
          type: string
        fields:
          type: object
          additionalProperties:
            $ref: '#/components/schemas/DoStateField'
    DoStateField:
      type: object
      title: DoStateField
      properties:
        code:
          type: string
        type:
          type: string
        name:
          type: string
        description:
          type: string
        sizeXs:
          type: integer
          format: int32
        sizeMd:
          type: integer
          format: int32
        value:
          type: string
        valueError:
          type: string
        required:
          type: boolean
        displayOrder:
          type: integer
          format: int32
        readOnly:
          type: boolean
          default: false
        extra:
          type: string
    Badge:
      type: object
      properties:
        code:
          type: string
        image:
          type: string
    Page:
      type: object
      properties:
        channel:
          type: string
        primary_nav_code:
          type: string
        secondary_nav_code:
          type: string
        widgets:
          type: array
          items:
            anyOf:
              - $ref: '#/components/schemas/BannerWidget'
              - $ref: '#/components/schemas/TileWidget'
    BannerWidget:
      type: object
      properties:
        type:
          type: string
          example: banner
        banners:
          type: array
          items:
            $ref: '#/components/schemas/Banner'
    TileWidget:
      type: object
      properties:
        type:
          type: string
          example: tiles
        title:
          type: string
        tile_size:
          type: string
        backgroundImage:
          type: string
        jackpots:
          type: array
          items:
            $ref: '#/components/schemas/Jackpot'
        tiles:
          type: array
          items:
            $ref: '#/components/schemas/Tile'
    Jackpot:
      type: object
      properties:
        title:
          type: string
        description:
          type: string
        balance:
          type: number
          format: decimal
        targetBalance:
          type: number
          format: decimal
        balanceCurrency:
          type: string
    Banner:
      type: object
      properties:
        id:
          type: number
          format: int64
        name:
          type: string
        display_text:
          type: string
        gameID:
          type: string
        from:
          type: string
        to:
          type: string
        url:
          type: string
        image:
          type: string
        sleep:
          type: number
          format: int64
        terms_url:
          type: string
        runcount:
          type: number
          format: int32
    Tile:
      type: object
      properties:
        type:
          type: string
        gameID:
          type: string
        gameName:
          type: string
        image:
          type: string
        badge:
          type: string
        balance:
          type: number
          format: decimal
        balanceCurrency:
          type: string
        runcount:
          type: number
          format: int32
    Pageable:
      type: object
      title: Page
      properties:
        content:
          type: array
          items:
            type: object
        last:
          type: boolean
        totalElements:
          type: integer
          format: int32
        totalPages:
          type: integer
          format: int32
        numberOfElements:
          type: integer
          format: int32
        size:
          type: integer
          format: int32
        number:
          type: integer
          format: int32
        first:
          type: boolean
        sort:
          type: array
          items:
            $ref: '#/components/schemas/PageableSort'
    PageableSort:
      type: object
      properties:
        direction:
          type: string
        property:
          type: string
        ignoreCase:
          type: boolean
        nullHandling:
          type: string
        ascending:
          type: boolean
    Restrictions:
      type: object
      title: Restrictions
      properties:
        casinoAllowed:
          type: boolean
        loginAllowed:
          type: boolean
        depositAllowed:
          type: boolean
        withdrawAllowed:
          type: boolean
        betPlacementAllowed:
          type: boolean
        compsAllowed:
          type: boolean
          example: true
        compsSystemPlaced:
          type: boolean
          example: true
          description: |
            A system placed comps block has been placed and the player's account
             and may not be removed by a player themselves. A system placed comps
              block restrictions are normally placed for a certain number of days
               and can also be removed by a backoffice user.
        compsErrorMessage:
          type: string
          example: The player has been blocked from receiving promotions
      
    TermsAndConditionsVersion:
      type: object
      title: TermsAndConditionsVersion
      properties:
        acceptedUserVersion:
          type: string
        currentDomainVersion:
          type: string
    InboxSummary:
      type: object
      properties:
        readCount:
          type: integer
          description: The amount of read message for the player
          example: 1
        unreadCount:
          type: integer
          description: The amount of unread message for the player
          example: 2
        ctaCount:
          type: integer
          description: | 
            The amount of 'Call To Action' Notification messages for the player, this will be used to display a popup for the player 
            on the frontend once an intervent message has been sent to the player
          example: 3
  securitySchemes:
    basicAuth:
      type: http
      scheme: basic
    httpBearer:
      type: http
      scheme: bearer
security:
  - basicAuth: []
  - httpBearer: []
